package com.caimei.model.po;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * cm_order_product
 *
 * @author
 */
@Data
public class CmOrderProductPo implements Serializable {
    private Integer orderProductID;

    /**
     * 主订单编号
     */
    private String orderNo;

    /**
     * 主订单ID
     */
    private Long orderID;

    /**
     * 订单Id
     */
    private Integer shopOrderID;

    /**
     * 子订单编号
     */
    private String shopOrderNo;

    /**
     * 供应商ID
     */
    private Long shopID;

    /**
     * 商品Id（采美商城和组织小程序都保存product表ID）
     */
    private Integer productID;

    /**
     * 组织的商品Id，关联cm_mall_organize_products表ID[适用于组织订单]
     */
    private Integer organizeProductID;

    /**
     * 采美组织默认为null,具体对应cm_mall_organize表ID[适用于组织订单]
     */
    private Integer organizeID;

    /**
     * 购买数量
     */
    private Integer num;

    /**
     * 赠送数量
     */
    private Integer presentNum;

    /**
     * 出库类型 0 采美出库  1 供应商出库
     */
    private String outStoreType;

    /**
     * skuId
     */
    private Integer skuID;

    /**
     * sku属性
     */
    private String props;

    /**
     * 属性名
     */
    private String propName;

    /**
     * 商品编号
     */
    private String productNo;

    /**
     * 商品价格(协销 市场价 普通 购买价)
     */
    private BigDecimal price;

    /**
     * 市场价 = 商品表市场价
     */
    private BigDecimal normalPrice;

    /**
     * 购买时商品成本价
     */
    private BigDecimal costPrice;

    /**
     * 记录普通用户购买时价格  活动价优先
     */
    private BigDecimal price0;

    /**
     * 记录会员用户购买时价格  活动价优先
     */
    private BigDecimal price1;

    /**
     * 总价  = price X num
     */
    private BigDecimal totalAmount;

    /**
     * 总价  = discountPrice X num + totalAddedValueTax
     */
    private BigDecimal totalFee;

    /**
     * 应付金额 = totalFee - discountFee
     */
    private BigDecimal shouldPayFee;

    /**
     * 折扣比例
     */
    private BigDecimal discount;

    /**
     * 折后单价
     */
    private BigDecimal discountPrice;

    /**
     * 是否含税 0不含税 1含税 2未知
     */
    private String includedTax;

    /**
     * 发票类型 1增值税专用发票 2增值税普通发票 3不开发票
     */
    private String invoiceType;

    /**
     * 启用阶梯价格标识 0否 1是
     */
    private String ladderPriceFlag;

    /**
     * 后台设置该商品税率
     */
    private BigDecimal taxRate;

    /**
     * 供应商税率:增值专用发票默认13%，增值税普通发票6%取值范围[0-100]
     */
    private BigDecimal supplierTaxRate;

    /**
     * 单个税费=税率X折后单价
     */
    private BigDecimal addedValueTax;

    /**
     * 总税费=单个税费X购买数量
     */
    private BigDecimal totalAddedValueTax;

    /**
     * 总税费(应付税费)默认值和应收税费一样
     */
    private BigDecimal shouldPayTotalTax;

    /**
     * 单个付供应商税费
     */
    private BigDecimal singleShouldPayTotalTax;

    /**
     * 商品费
     */
    private BigDecimal shopProductAmount;

    /**
     * 该商品总的应付供应商金额
     */
    private BigDecimal shopFee;

    /**
     * 该商品总的应付第三方金额
     */
    private BigDecimal otherFee;

    /**
     * 该商品总的应付采美金额 (受赠品影响)
     */
    private BigDecimal cmFee;

    /**
     * 后台设置的单个应付供应商金额
     */
    private BigDecimal singleShopFee;

    /**
     * 后台设置单个应付第三方金额
     */
    private BigDecimal singleOtherFee;

    /**
     * 后台计算的单个应付采美金额
     */
    private BigDecimal singleCmFee;

    /**
     * 订单商品状态
     */
    private String status;

    /**
     * 是否已评论：1是，空或0未评论(V5.0.0版本后已废弃--)
     */
    private String commentFlag;

    /**
     * 获取到的总采美豆值
     */
    private BigDecimal totalBeans;

    /**
     * 使用余额金额
     */
    private Double useBalanceAmount;

    /**
     * 使用采美豆数量
     */
    private Integer useBeanAmount;

    /**
     * 未出库数量
     */
    private Integer notOutStore;

    /**
     * 当前采美豆专区价格(采美豆)
     */
    private Integer cmbeanPrice;

    /**
     * 下单时商品购买价格类型快照 0 机构价，1活动价 ，2阶梯价
     */
    private String isActProduct;

    /**
     * 是否是赠品 0 不是 1 是
     */
    private String isGiftProduct;

    /**
     * 活动信息 已享受满XX减XX 之类
     */
    private String productActInfo;

    /**
     * 订单商品再次购买标识 0否 1是
     */
    private String buyAgainFlag;

    /**
     * 订单商品供应商确认标志 0否 1是
     */
    private String confirmProductFlag;

    /**
     * 支付状态 0 未进账 1 待财务审核 2 已进账(适用协销的单笔线下进账和自助订单线下或异常进账)
     */
    private String payStatus;

    /**
     * 供应商名称
     */
    private String shopName;

    /**
     * 商品名称
     */
    private String name;

    /**
     * 商品单位
     */
    private String productUnit;

    private String productImage;

    /**
     * 活动类型 1000 热卖 1001 团购 1003 满减 1004满赠 1005 买赠
     */
    private String actType;

    /**
     * 活动优惠  类似满减优惠金额
     */
    private BigDecimal actPreferential;

    /**
     * 商品类型(0正常商品,1协商赠品,2促销赠品)
     */
    private String productType;

    /**
     * 订单促销id
     */
    private Integer orderPromotionsId;

    /**
     * 优惠 (price - discountPrice) * num
     */
    private BigDecimal preferential;

    /**
     * 协销订单:经理折扣(平摊到每个商品上,  按照每种商品的总价占订单总价的比例来均分);普通订单 无
     */
    private BigDecimal discountFee;

    private Integer cancelNum;

    private static final long serialVersionUID = 1L;
}