package com.caimei.service;

import com.caimei.model.ResponseJson;

import java.util.List;
import java.util.Map;

/**
 * Description
 *
 * @author : plf
 * @date : 2021/4/25
 */
public interface OrderSubmitService {
    /**
     * 商品结算
     *
     * @param productIds   商品ID串用逗号隔开。
     * @param productCount 立即购买商品数量
     * @param userId       用户id。
     * @return
     */
    ResponseJson<Map<String, Object>> orderConfirm(String productIds, Integer productCount, Integer userId);

    /**
     * 提交订单
     *
     * @param userId
     * @param cartType
     * @param addressId
     * @param orderInfo
     * @param payInfo
     * @return
     */
    ResponseJson<Map<String, String>> orderSubmit(Integer userId, Integer cartType, Integer addressId, List<Map<String, Object>> orderInfo, Map<String, Object> payInfo);
}
