package com.caimei.service;

import com.caimei.model.ResponseJson;
import com.caimei.model.vo.ProductVo;
import com.github.pagehelper.PageInfo;

import java.util.List;

/**
 * Description
 *
 * @author : plf
 * @date : 2021/4/22
 */
public interface ProductService {
    /**
     * 轮播图
     *
     * @return
     */
    ResponseJson<List<String>> carouselFigure();

    /**
     * 商品列表
     *
     * @param name     商品名称
     * @param userId   用户id
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseJson<PageInfo<ProductVo>> productList(String name, Integer userId, Integer pageNum, Integer pageSize);

    /**
     * 商品详情
     *
     * @param productId 商品id
     * @return
     */
    ResponseJson<ProductVo> productDetails(Integer productId);

    /**
     * 商品搜索历史记录
     *
     * @param userId 用户id
     * @return
     */
    ResponseJson<List<String>> searchHistory(Integer userId);

    /**
     * 删除搜索历史记录
     *
     * @param userId 用户id
     * @return
     */
    ResponseJson<String> deleteHistory(Integer userId);
}
